hdu 4609 3-idiots —— FFT

题目:http://acm.hdu.edu.cn/showproblem.php?pid=4609

算不合法的比较方便;

枚举最大的边,每种情况算了2次,而全排列算了6次,所以还要乘3;

注意枚举最大边的范围是 mx 而不是 lim !!否则会超过开的数组范围!!!

代码如下:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
using namespace std;
typedef double db;
typedef long long ll;
int const xn=(1<<20),xm=1e5+5;
db const Pi=acos(-1.0);
int n,rev[xn],lim,num[xm];
struct com{db x,y;}a[xn];
com operator + (com a,com b){return (com){a.x+b.x,a.y+b.y};}
com operator - (com a,com b){return (com){a.x-b.x,a.y-b.y};}
com operator * (com a,com b){return (com){a.x*b.x-a.y*b.y,a.x*b.y+a.y*b.x};}
int rd()
{
  int ret=0,f=1; char ch=getchar();
  while(ch<‘0‘||ch>‘9‘){if(ch==‘-‘)f=0; ch=getchar();}
  while(ch>=‘0‘&&ch<=‘9‘)ret=ret*10+ch-‘0‘,ch=getchar();
  return f?ret:-ret;
}
void fft(com *a,int tp)
{
  for(int i=0;i<lim;i++)
    if(i<rev[i])swap(a[i],a[rev[i]]);
  for(int mid=1;mid<lim;mid<<=1)
    {
      com wn=(com){cos(Pi/mid),tp*sin(Pi/mid)};
      for(int j=0,len=(mid<<1);j<lim;j+=len)
    {
      com w=(com){1,0};
      for(int k=0;k<mid;k++,w=w*wn)
        {
          com x=a[j+k],y=w*a[j+mid+k];
          a[j+k]=x+y; a[j+mid+k]=x-y;
        }
    }
    }
  if(tp==1)return;
  for(int i=0;i<lim;i++)a[i].x=a[i].x/lim;
}
int main()
{
  int T=rd();
  while(T--)
    {
      n=rd(); int mx=0;
      memset(num,0,sizeof num);
      for(int i=1,x;i<=n;i++)x=rd(),num[x]++,mx=max(mx,x);
      lim=1; int l=0;
      while(lim<=mx+mx)lim<<=1,l++;
      for(int i=0;i<lim;i++)
    rev[i]=((rev[i>>1]>>1)|((i&1)<<(l-1)));
      for(int i=0;i<lim;i++)a[i].x=0,a[i].y=0;
      for(int i=0;i<=mx;i++)a[i].x=num[i];
      fft(a,1);
      for(int i=0;i<lim;i++)a[i]=a[i]*a[i];
      fft(a,-1);
      for(int i=2;i<lim;i+=2)a[i].x=(ll)(a[i].x+0.5)-num[i/2];
      ll sum=(ll)n*(n-1)*(n-2),ans=sum; ll pre=0;
      for(int i=0;i<=mx;i++)//mx
    {
      pre+=3*(ll)(a[i].x+0.5);
      if(num[i])ans-=num[i]*pre;//num[i]*...!
    }
      printf("%.7f\n",1.0*ans/sum);
    }
  return 0;
}

原文地址:https://www.cnblogs.com/Zinn/p/10099831.html

时间: 2024-10-03 10:22:32

hdu 4609 3-idiots —— FFT的相关文章

hdu 4609 3-idiots 【FFT快(gui)速傅立叶变换】

FFT实现起来挺复杂的,开始用vector,结果发现空间超了,换成数组还是超,删掉了几个后又超时了 sin cos 函数调用次数太多了,改成乘法,还是超时 最后把FFT里的除法运算和模运算优化了一下,终于过了,排的老后面 坑,3843MS,一看时间最少的只有671MS,我都怀疑这是不是同一个算法..为毛差距这么大 #pragma comment(linker, "/STACK:102400000,102400000") #include<iostream> #include

hdu 4609 3-idiots (FFT+计数)

3-idiots Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 2382    Accepted Submission(s): 822 Problem Description King OMeGa catched three men who had been streaking in the street. Looking as i

HDU 4609 3-idiots(FFT)

题意:给出n个正整数(数组A).每次随机选出三个数.问这三个数能组成三角形的概率为多大? 首先,我们用类似桶排计数的方法作出两个数组a,b,储存每个长度有几条边,然后对两个数组求卷积. 求出卷积后,这就代表了2条边能构成的边长度的集合了,注意,由于求卷积的时候可能把两条相同的边相加,所以最后求出的数组一定要减去这重复的部分,然后,先算x后算y等价于先算y后算x,所以要除以二. 然后,对于第三条边a[i],我们这样考虑:令它作为这三条边中最大的那条! 所以之前的卷积求出来的两边和一定会比这条边大,

HDU 4609 3-idiots ——(FFT)

这是我接触的第一个关于FFT的题目,留个模板. 这题的题解见:http://www.cnblogs.com/kuangbin/archive/2013/07/24/3210565.html. FFT的模板如下: 1 #include<bits/stdc++.h> 2 using namespace std; 3 const double pi = atan(1.0)*4; 4 struct Complex { 5 double x,y; 6 Complex(double _x=0,double

HDU 4609 3-idiots fft

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4609 题目描述:给出n个数, 问其中选出三个能组成三角形的概率 解题思路:给出kuangbin巨巨的解题思路, 实在是没有比这儿更好的题解, 所以我就不误导别人和自己了 http://www.cnblogs.com/kuangbin/archive/2013/07/24/3210565.html 题目代码: #include <iostream> #include <cstdio> #

【FFT】HDU 4609 3-idiots

通道:http://acm.hdu.edu.cn/showproblem.php?pid=4609 题意:n条边长,求任选3条能组成三角形的概率. 思路:求出res后,减去一大一下,减去都大于它的边,减去该边和其他边组成的方案. 代码: 1 #include <cstdio> 2 #include <cstring> 3 #include <cmath> 4 #include <algorithm> 5 6 const int N =400007; 7 8

FFT(快速傅里叶变换):HDU 4609 3-idiots

3-idiots Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3560    Accepted Submission(s): 1241 Problem Description King OMeGa catched three men who had been streaking in the street. Looking as i

HDU 4609 3-idiots FFT+容斥

一点吐槽:我看网上很多分析,都是在分析这个题的时候,讲了半天的FFT,其实我感觉更多的把FFT当工具用就好了 分析:这个题如果数据小,统计两个相加为 x 的个数这一步骤(这个步骤其实就是求卷积啊),完全可以母函数,无奈数据很大,就用FFT了 然后难点在于最后的统计,要减去自身,两个都大的,一大一小,包含自身,这是用到了容斥,再做相似的题的时候,应该多看看这方面 注:再次高度仰慕kuangbin神,这是我FFT的第二题,也是第二次用kuangbin FFT模板 #include <stdio.h>

HDU 4609 3-idiots(FFT计数)

题意:给n(n<=100000)根棍子.每根棍子的长度是m(m<=100000),求从中任意取出三根的概率: 题解:经典FFT计数...枚举最长边..然后经过一系列玄学取重就可以啦..好神奇呀..细节见代码. #include<bits/stdc++.h> using namespace std; #define pie acos(-1.0) const int maxn = 4e5 + 10; typedef long long ll; struct Cp{double x,y;